package betterquesting.api2.client.gui.events;

import cpw.mods.fml.common.eventhandler.SubscribeEvent;
import java.util.HashMap;
import java.util.Map;
import java.util.function.Consumer;
import javax.annotation.Nonnull;
import net.minecraftforge.client.event.GuiOpenEvent;

/* loaded from: betterquesting_api2_client_gui_events.jar:betterquesting/api2/client/gui/events/PEventBroadcaster.class */
public class PEventBroadcaster {
    public static PEventBroadcaster INSTANCE = new PEventBroadcaster();
    private final HashMap<Class<? extends PanelEvent>, PEventEntry<? extends PanelEvent>> entryList = new HashMap<>();

    @Deprecated
    public void register(@Nonnull IPEventListener l, @Nonnull Class<? extends PanelEvent> type) {
        l.getClass();
        register(l::onPanelEvent, type);
    }

    public void register(@Nonnull Consumer<PanelEvent> consumer, @Nonnull Class<? extends PanelEvent> type) {
        PEventEntry<?> pe = this.entryList.computeIfAbsent(type, PEventEntry::new);
        pe.registerListener(consumer);
    }

    public void register(@Nonnull Consumer<PanelEvent> consumer, @Nonnull Iterable<Class<? extends PanelEvent>> type) {
        type.forEach(c -> {
            PEventEntry<?> pe = this.entryList.computeIfAbsent(c, PEventEntry::new);
            pe.registerListener(consumer);
        });
    }

    @Deprecated
    public void unregister(IPEventListener l) {
        l.getClass();
        unregister(l::onPanelEvent);
    }

    public void unregister(@Nonnull Consumer<PanelEvent> consumer) {
        this.entryList.values().forEach(value -> {
            value.unregisterListener(consumer);
        });
    }

    public boolean postEvent(@Nonnull PanelEvent event) {
        for (Map.Entry<Class<? extends PanelEvent>, PEventEntry<? extends PanelEvent>> e : this.entryList.entrySet()) {
            if (e.getKey().isAssignableFrom(event.getClass())) {
                e.getValue().fire(event);
            }
        }
        return event.canCancel() && event.isCancelled();
    }

    @SubscribeEvent
    public void onGuiOpened(GuiOpenEvent event) {
        this.entryList.clear();
    }
}
